#!/usr/bin/perl -w
use strict;


#  Copyright (C) 2002 Adrian Ulrich <pab at blinkenlights.ch>
#  Part of the gnupod-tools collection
#
#  URL: http://www.blinkenlights.ch/cgi-bin/fm.pl?get=ipod
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# iTunes and iPod are trademarks of Apple
#
# This product is not supported/written/published by Apple!



print "mktunes.pl 0.2 (C) 2002 Adrian Ulrich\n";
print "Part of the gnupod-tools collection\n";
print "This tool updates your iTunesDB with the content of the gnuPodDB\n\n";


use vars qw($sid $start_sid);

$sid = 123; #First songID .. iTunes doesn't start at '1' .. it starts ~120
$start_sid = $sid;


if($ARGV[0])
{ 
 stdtest(); #test if setup is sane
print "This action will *REPLACE* your current iTunesDB with the contents of the\n";
print "current GNUpod file\n\nHit ENTER to continue, CTRL+C to abort\n";
<STDIN>;
parse("$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB");

}
else
{ die "Usage: mktunes.pl IPOD_MOUNTPOINT\n";}


sub parse
{
my($file, $i, $foo, @ding, $songs, $bar, $mhlt, $mhsd, $playlist, $s_mhsd, $now);
($file) = @_;
 open(DB, "$file") or die "Could not open $file\no Correct mountpoint?\n";
 print "-------------------------------\n";
 print "!! Parsing and creating mhits..";
  while(defined($i = <DB>))
   {
        if(substr($i, 0, 1) ne "\#") 
	{
	 chomp($i);
         @ding = split(/\t/, $i);
	  if(@ding)
	   {
	    $songs++;
	    $foo = mk_mhit($ding[0], $ding[1], $ding[2], $ding[3], $ding[4], $ding[5], $ding[6]);
	    $bar = $bar.$foo;
	   } 
	 }  
   }


die "FATAL: no songs found in this gnuPod file.. did you add songs?\nuse gnupod_addsong.pl to do this\n" if (!$songs);

open(ITUNES, "> $ARGV[0]/iPod_Control/iTunes/iTunesDB");
print "..done!\n\n-> Creating songDB header\n"; 
   $mhlt = mk_mhlt($songs);      #generate songDBheader
   $mhsd = mk_mhsd($mhlt.$bar, 1);
 # first db        #sheader #song items   
print "=> Packed songDB\n";

#second part of itunesDB (playlist and prefs part)
print "\n-> Creating main playlist\n";
     $playlist = mk_mhlp(mk_mhyp(mk_playlist()));
     $s_mhsd   = mk_mhsd($playlist, 2);   #create second mhsd header         
 print "=> Packed main playlist\n\n";

print ITUNES mk_mhbd($mhsd.$mhlt.$bar.$s_mhsd.$playlist); #create and print iTunesDB header
 
 print "-> Generated DB-Header\n";

print ITUNES $mhsd.$mhlt.$bar.$s_mhsd.$playlist; #print content
close(ITUNES);

#touching gnupod file, it has to be newer than the itunesdb 
 $now = time;
 utime $now, $now, "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB";



 print "=> Wrote iTunesDB\n";
 print "-------------------------------\n";
 print "Songs on your iPod: $songs\n\n";

print ("\n     May the iPod be with you!\n\n");
}





sub mk_mhlp #dummy
{
my($dull, $ret);
($dull) = @_;
 $ret = "mhlp";
 $ret = $ret.pack("H8", reverse("5C"));
 $ret = $ret.pack("H8", reverse("01"));
 $ret = $ret.pack("h160", "00");
return $ret.$dull;
}


sub mk_mhyp
{
my($dull, $xsiz, $ret, $xsongs);
($dull) = @_;
 
 $dull = mk_weired().mk_mhod(1, "LUNIX").$dull; #itunes prefs & ipod name (LUNIX)
   
   $xsiz = reverse(sprintf("%08X", (length($dull)+108) ));
   $xsongs = reverse(sprintf("%08X", ($sid-$start_sid)));
   
 $ret = "mhyp";
 $ret = $ret.pack("H8", reverse("6C")); #type?
 $ret = $ret.pack("h8", $xsiz);         #size
  $ret = $ret.pack("H8", reverse("02"));#?
   
   $ret = $ret.pack("h8", $xsongs);    #songs in pl
  $ret = $ret.pack("H8", reverse("01")); #?
  $ret = $ret.pack("H8", reverse("00")); #?
  $ret = $ret.pack("H8", reverse("00")); #?
  $ret = $ret.pack("H8", reverse("00")); #?
  $ret = $ret.pack("H144", "00");       #dummy space
 $ret = $ret.$dull;
 return $ret;
}


#generates a default playlist (in mhip's)
sub mk_playlist
{
my($i, $ret);
 

for($i=0;$i<=($sid-$start_sid-1);$i++)
 {
  
  $ret = $ret.mk_mhip(($i+$start_sid));
  $ret = $ret.mk_mhod(100, "", ($i+$start_sid));
 }
 
 #now we got all DEFAULT-PLAYLIST-mhods we need 
 
 
  return $ret;
}


sub mk_mhip
 {
 my($id, $ret, $xid);
 ($id) = @_;
 
  $xid = reverse(sprintf("%08X", "$id"));
 
 $ret = "mhip";
 $ret = $ret.pack("H8", reverse("4C"));
 $ret = $ret.pack("H8", reverse("4C"));
 $ret = $ret.pack("H8", reverse("01"));
 $ret = $ret.pack("H8", reverse("00"));
 $ret = $ret.pack("h8", $xid); #song id in playlist
 $ret = $ret.pack("h8", $xid); #ditto.. don't know the difference, but this seems to work
 $ret = $ret.pack("H96", "00");
  return $ret;
 }


sub mk_mhbd
{
my($ret, $dullme, $x_siz);
($dullme) = @_;
$x_siz = reverse(sprintf("%08X",((length($dullme))+104)));
$ret = "mhbd";
$ret = $ret.pack("H8", reverse(68)); #Header Size
$ret = $ret.pack("h8", $x_siz);  #size of the whole mhdb
$ret = $ret.pack("H8", "01"); #?
$ret = $ret.pack("H8", "01"); #? - changed to 2 from itunes2 to 3 .. version?
$ret = $ret.pack("H8", "02"); #?
$ret = $ret.pack("H160", "00"); #dummy space
}


sub mk_mhsd
{
my($ret, $whole_file, $siz, $type);
($whole_file, $type) = @_;
$siz = reverse(sprintf("%08X",length($whole_file)+96));
$ret = "mhsd";
$ret = $ret.pack("H8", 60);            #Headersize, static
$ret = $ret.pack("h8", $siz);          #size
$ret = $ret.pack("H8", "0".$type);     #type .. 1 = song .. 2 = playlist
$ret = $ret.pack("H160", "00");        #dummy space
return $ret;
}



sub mk_mhlt
{
my($ret, $songnum,$xsongnum);
($songnum) = @_;
$xsongnum = reverse(sprintf("%08X", "$songnum"));

$ret = "mhlt";
$ret = $ret.pack("H8", reverse("5C")); #Header size (static?)
$ret = $ret.pack("h8", $xsongnum);     #songs in this itunesdb
$ret = $ret.pack("H160", "00");      #dummy space
return $ret;
}


sub mk_mhit 
{
#filename - seconds - size - name - artist - album
my($m_name, $m_br, $m_artist, $m_album, $m_filename, $m_seconds, $m_size, $ret);
($m_filename, $m_br, $m_seconds, $m_size, $m_name, $m_artist, $m_album) = @_;





my($xhod, $xhod_z, $xhod_l, $xdat, $xsize, $xsec, $xsid, $xmbr);
$xhod_z = 5; #we ALWAY get 5 entrys (in this version..)

#generating _all_ mhod's
$xhod = mk_mhod(1, $m_name).mk_mhod(4, $m_artist).mk_mhod(3, $m_album).mk_mhod(6, "MPEG-Tondatei").mk_mhod(2, $m_filename);
$xhod_l = (length($xhod)+156);
$xhod_l = reverse(sprintf("%08X", $xhod_l));

$xmbr = reverse(sprintf("%08X", $m_br));

$xdat = mactime();
$xdat = reverse($xdat);

$xsize = reverse(sprintf("%08X", $m_size));
$xsec = reverse(sprintf("%08X", $m_seconds));
$xsid = reverse(sprintf("%08X", "$sid"));

$ret = "mhit";
$ret = $ret.pack("H8", reverse("9C")); #header size
$ret = $ret.pack("h8", $xhod_l); #len of this entry
$ret = $ret.pack("h8", $xhod_z); #num of mhods in this mhit
$ret = $ret.pack("h8", $xsid); #Song index number
$ret = $ret.pack("H8", reverse("01"));
$ret = $ret.pack("H8");
$ret = $ret.pack("H8", reverse("0001")); #type (fixme)
$ret = $ret.pack("h8", $xdat);           #timestamp
$ret = $ret.pack("h8", $xsize);          #filesize
$ret = $ret.pack("h8", $xsec);           #seconds of song
$ret = $ret.pack("h8", "00");            #nr. on CD .. we dunno use it 
$ret = $ret.pack("H16");
$ret = $ret.pack("h8", $xmbr);           #bitrate
$ret = $ret.pack("H8", "000044AC");      #whats this?!
$ret = $ret.pack("H80");                #hardcoded space
$ret = $ret.pack("h8", reverse(mactime())); #dummy timestamp
$ret = $ret.pack("H96");
$ret = $ret.$xhod;

$sid++;
return $ret;
}








sub mk_mhod
{

# - type id
#1 titel
#2 ipod filename
#3 album
#4 interpret
#5 genere
#6 filetype
#7 ??????
#8 comment
#100 - Playlist item

my($string, $mlen, $slen, $type, $ret, $xtype, $fqid, $xfqid);

($type, $string, $fqid) = @_;

if(!$fqid) { 
 $mlen = reverse(sprintf("%x",length(ipod_string($string))+40)); #whole mhod length
 $slen = reverse(sprintf("%x",length(ipod_string($string))));    #string lenght
 $fqid = 1; 
}
else {
 $mlen = reverse(sprintf("%x", 44));
 $slen = 0;
}


$xtype = reverse(sprintf("%x", $type));                          #type of entry
$xfqid = reverse(sprintf("%08X", $fqid));
$ret = "";
$ret = "mhod";                #header
$ret = $ret.pack("H8", reverse("18"));      #size of header
$ret = $ret.pack("h8", reverse("$mlen"));   #$slen+40 - size of header+body
$ret = $ret.pack("h8", reverse("$xtype"));   #type of the entry
$ret = $ret.pack("h16");           #trash
$ret = $ret.pack("h8", reverse("$xfqid"));      #Song ID in the db
$ret = $ret.pack("h8", reverse("$slen"));   #size of string

if($type < 100){
 $ret = $ret.pack("h16");           #trash
 $ret = $ret.ipod_string($string);  #the string
}
else {
 $ret = $ret.pack("h24"); #playlist mhods are a different
}

return $ret;
}



# 'hello' -> 'h\0e\0l\0\l\0o' .. :)
sub ipod_string {
my($xx, $i, $ret);
($xx) = @_;
for($i=0;$i<=length($xx)-1;$i++) {
$ret = $ret.substr($xx, $i, 1)."\0";
 }
return $ret;
}



sub mactime {
#WARNING!!!! the time returned is NOT CORRECT!!!
# its _more ore less_ correct!!
#
# BUT!!! ITS CORRECT ENOUG FOR US!
my($x, $y);
$x  = time();
$x += 2207520000;
$y = sprintf("%08X", $x);
return $y;
}


sub stdtest
{
if(!(-w "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB"))
{
 print "Error: Cant write to your gnuPod-file\ndid you run 'gnupod_INITpod.pl' ?\n";
 exit(1);
}
if(!(-w "$ARGV[0]/iPod_Control/iTunes/iTunesDB"))
{
 print "Error: Cant write to your iTunesDB\n";
 exit(1);
}

if ((-M "$ARGV[0]/iPod_Control/.gnupod/GNUtunesDB") > (-M "$ARGV[0]/iPod_Control/iTunes/iTunesDB"))
{
 print "Error: your gnuPod-file is older than your iTunesDB! (Last update not done with gnuPod?)\n";
 print "Please run this comment to correct this issue:\n";
 print "tunes2pod.pl \$IPOD_MOUNTPOINT/iPod_Control/iTunes/iTunesDB > \$IPOD_MOUNTPOINT/iPod_Control/.gnupod/GNUtunesDB\n\n";
 print "This comment will update your current gnuPodfile with the contents of your (newer) iTunesDB\n";
 
 exit(1);
}

return 0;
}



#this is a WIRED mhod.. we create a dummyentry
sub mk_weired
{
my($ret, $foobar);
$ret = "mhod";                #header
$ret = $ret.pack("H8", reverse("18"));      #size of header
$ret = $ret.pack("H8", reverse("8802"));   #$slen+40 - size of header+body
$ret = $ret.pack("H8", reverse("64"));   #type of the entry
$ret = $ret.pack("H48", "00");
$ret = $ret.pack("H8", reverse("840001")); #?
$ret = $ret.pack("H8", reverse("05")); #?
$ret = $ret.pack("H8", reverse("09")); #?
$ret = $ret.pack("H8", reverse("03")); #?
$ret = $ret.pack("H32", reverse("010012")); #static?
$ret = $ret.pack("H32", reverse("0200C8")); #static?
$ret = $ret.pack("H32", reverse("0D003C")); #?
$ret = $ret.pack("H32", reverse("04007D")); #static?
$ret = $ret.pack("H32", reverse("03007D")); #static?
$ret = $ret.pack("H32", reverse("080064")); #static?

$ret = $ret.pack("H8", reverse("170064")); #static?
$ret = $ret.pack("H8", reverse("01"));      #bool?
$ret = $ret.pack("H16", "00");
$ret = $ret.pack("H8", reverse("140050")); #static?
$ret = $ret.pack("H8", reverse("01"));      #bool?
$ret = $ret.pack("H16", "00");
$ret = $ret.pack("H8", reverse("15007D")); #static?
$ret = $ret.pack("H8", reverse("01"));      #bool?
$ret = $ret.pack("H912", "00");

# This seems to be an itunespref thing.. dunno know this
# but if we set everything to 0, itunes doesn't show any data
# even if you drag an mp3 to your ipod: nothing is shown, but itunes
# will copy the file! 
# .. so we create a hardcoded-pref.. this will change in future

return $ret
}
